import { Codegen } from '../../../util/codegen';
import type { TypeSystem } from '../../system';
import type { Type } from '../../type';
export type CompiledCapacityEstimator = (value: any) => number;
export interface CapacityEstimatorCodegenContextOptions {
    type: Type;
    system?: TypeSystem;
    name?: string;
}
export declare class CapacityEstimatorCodegenContext {
    readonly options: CapacityEstimatorCodegenContextOptions;
    readonly codegen: Codegen<CompiledCapacityEstimator>;
    constructor(options: CapacityEstimatorCodegenContextOptions);
    inc(inc: number): void;
    compile(): CompiledCapacityEstimator;
}
