/// <reference types="node" />
import * as net from 'net';
import { FanOut } from 'thingies/es2020/fanout';
import type { WsFrameEncoder } from '../codec/WsFrameEncoder';
export declare class WsServerConnection {
    protected readonly encoder: WsFrameEncoder;
    readonly socket: net.Socket;
    closed: boolean;
    maxIncomingMessage: number;
    maxBackpressure: number;
    protected stream: FanOut<Uint8Array> | null;
    readonly defaultOnPing: (data: Uint8Array | null) => void;
    onmessage: (data: Uint8Array, isUtf8: boolean) => void;
    onping: (data: Uint8Array | null) => void;
    onpong: (data: Uint8Array | null) => void;
    onclose: (code: number, reason: string) => void;
    constructor(encoder: WsFrameEncoder, socket: net.Socket);
    close(): void;
    private onClose;
    upgrade(secWebSocketKey: string, secWebSocketProtocol: string, secWebSocketExtensions: string): void;
    private __buffer;
    private __writeTimer;
    write(buf: Uint8Array): void;
    sendPing(data: Uint8Array | null): void;
    sendPong(data: Uint8Array | null): void;
    sendBinMsg(data: Uint8Array): void;
    sendTxtMsg(txt: string): void;
}
