import { ITimestampStruct } from '../../../json-crdt-patch/clock';
import { AbstractRga, Chunk } from '../rga/AbstractRga';
import type { JsonNode } from '..';
export declare class StrChunk implements Chunk<string> {
    readonly id: ITimestampStruct;
    span: number;
    del: boolean;
    data: string;
    len: number;
    p: StrChunk | undefined;
    l: StrChunk | undefined;
    r: StrChunk | undefined;
    p2: StrChunk | undefined;
    l2: StrChunk | undefined;
    r2: StrChunk | undefined;
    s: StrChunk | undefined;
    constructor(id: ITimestampStruct, span: number, str: string);
    merge(str: string): void;
    split(ticks: number): StrChunk;
    delete(): void;
    clone(): StrChunk;
}
export declare class StrNode<T extends string = string> extends AbstractRga<string> implements JsonNode<string> {
    children(): void;
    child(): undefined;
    container(): JsonNode | undefined;
    private _view;
    view(): T;
    api: undefined | unknown;
    name(): string;
    createChunk(id: ITimestampStruct, str: string | undefined): StrChunk;
    protected onChange(): void;
    protected toStringName(): string;
}
