import type { RpcSpecifier } from '../rpc';
import type { ReactiveRpcMessage } from '../messages';
import type { JsonValueCodec } from '../../../json-pack/codecs/types';
import type { RpcMessageCodec } from './types';
export declare class RpcCodec {
    readonly msg: RpcMessageCodec;
    readonly req: JsonValueCodec;
    readonly res: JsonValueCodec;
    constructor(msg: RpcMessageCodec, req: JsonValueCodec, res: JsonValueCodec);
    specifier(): RpcSpecifier;
    encode(messages: ReactiveRpcMessage[], valueCodec: JsonValueCodec): Uint8Array;
    decode(data: Uint8Array, valueCodec: JsonValueCodec): ReactiveRpcMessage[];
}
