export interface ITimestampStruct {
    readonly sid: number;
    time: number;
}
export interface ITimespanStruct extends ITimestampStruct {
    readonly span: number;
}
export interface IClock extends ITimestampStruct {
    tick(cycles: number): ITimestampStruct;
}
export interface IClockVector extends IClock {
    readonly peers: Map<number, ITimestampStruct>;
    observe(ts: ITimestampStruct, span: number): void;
    clone(): IClockVector;
    fork(sessionId: number): IClockVector;
    toString(tab?: string): string;
}
