export const remove = ({ t, services }) => (r) => {
    const Request = t.Object(t.prop('id', t.Ref('BlockId')).options({
        title: 'Block ID',
        description: 'The ID of the block to delete.',
    }));
    const Response = t.obj;
    const Func = t.Function(Request, Response).options({
        title: 'Read Block',
        intro: 'Retrieves a block by ID.',
        description: 'Fetches a block by ID.',
    });
    return r.prop('blocks.remove', Func, async ({ id }) => {
        await services.blocks.remove(id);
        return {};
    });
};
