import { FanOut } from 'thingies/es2020/fanout';
import type { JsonNode, JsonNodeView } from '../../nodes';
import type { SyncStore, SyncStoreUnsubscribe } from '../../../util/events/sync-store';
import type { NodeApi } from './nodes';
export declare class NodeEvents<N extends JsonNode = JsonNode> implements SyncStore<JsonNodeView<N>> {
    private readonly api;
    readonly onChanges: FanOut<JsonNodeView<N>>;
    readonly onViewChanges: FanOut<JsonNodeView<N>>;
    constructor(api: NodeApi<N>);
    handleDelete(): void;
    readonly subscribe: (callback: () => void) => SyncStoreUnsubscribe;
    readonly getSnapshot: () => JsonNodeView<N>;
}
