import type { CompactEndsOp } from '../codec/compact/types';
import { AbstractPredicateOp } from './AbstractPredicateOp';
import { OperationEnds } from '../types';
import { Path } from '../../json-pointer';
import { OPCODE } from '../constants';
import { AbstractOp } from './AbstractOp';
import type { IMessagePackEncoder } from '../../json-pack/msgpack';
export declare class OpEnds extends AbstractPredicateOp<'ends'> {
    readonly value: string;
    readonly ignore_case: boolean;
    constructor(path: Path, value: string, ignore_case: boolean);
    op(): "ends";
    code(): OPCODE;
    test(doc: unknown): boolean;
    toJson(parent?: AbstractOp): OperationEnds;
    toCompact(parent: undefined | AbstractOp, verbose: boolean): CompactEndsOp;
    encode(encoder: IMessagePackEncoder, parent?: AbstractOp): void;
}
