"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createBinaryWsRpcClient = void 0;
const cbor_1 = require("../../json-pack/codecs/cbor");
const Writer_1 = require("../../util/buffers/Writer");
const common_1 = require("../common");
const RpcCodec_1 = require("../common/codec/RpcCodec");
const binary_1 = require("../common/codec/binary");
const createBinaryWsRpcClient = (url, token) => {
    const writer = new Writer_1.Writer(1024 * 4);
    const msg = new binary_1.BinaryRpcMessageCodec();
    const req = new cbor_1.CborJsonValueCodec(writer);
    const codec = new RpcCodec_1.RpcCodec(msg, req, req);
    const client = new common_1.RpcPersistentClient({
        codec,
        channel: {
            newChannel: () => new common_1.WebSocketChannel({
                newSocket: () => new WebSocket(url, [codec.specifier(), token]),
            }),
        },
    });
    client.start();
    return client;
};
exports.createBinaryWsRpcClient = createBinaryWsRpcClient;
